#include <dos.h>
#include <stdlib.h>
#include <math.h>

char far *vga = MK_FP(0xA000, 0);
const float PI = 3.1415927;
int CosArray[360], SinArray[360];

/*
	These routines are from the 1st and 2nd parts of the tutorial
*/
void SetMode13h()
{
	union REGS regs;
	regs.x.ax = 0x013;
	int86(0x10, &regs, &regs);
}

void SetTextMode()
{
	union REGS regs;
	regs.x.ax = 0x003;
	int86(0x10, &regs, &regs);
}

void PlotPixel(int x, int y, char colour)
{
	*(vga + (y * 320) + x)=colour;
}

void VerticalLine(int x, int y1, int y2, int colour)
{
	int ycount;

	for(ycount = y1; ycount <= y2; ycount++)
	{
		*(vga+(ycount*320)+x)=colour;
	}
}
/*
	Our circle drawing functions
*/

// Generate our arrays of SIN and COS values
void LoadCircleArrays()
{
	int a;
	float radians;

	for(a = 0; a < 360; a++)
	{
		radians = (float)a * PI / 180;
		CosArray[a] = (int)(cos(radians) * 100);
		SinArray[a] = (int)(sin(radians) * 100);
	}
}

// Draws a hollow circle
void Circle(int xc, int yc, int r, int color)
{
	int x,y,s;

	for(s = 0; s < 360; s++)
	{
		x = xc + ( ( r * CosArray[s] ) / 100 );
		y = yc + ( ( r * SinArray[s] ) / 100 );
		PlotPixel(x,y,color);
	}
}

// Draws a filled circle
void FilledCircle(int xc, int yc, int r, int color)
{
	int x, y1, y2, s;
	for(s = 0; s < 180; s++)
	{
		x  = xc + ((r * CosArray[s]) / 100);
		y1 = yc - ((r * SinArray[s]) / 100);
		y2 = yc + ((r * SinArray[s]) / 100);
		VerticalLine(x, y1, y2, color);
	}
}

void main()
{
	SetMode13h();

	LoadCircleArrays();	// load our arrays

	// loop while not keypressed
	while(!kbhit())
	{
		//draw randomly colored circle in random places
		Circle(random(320),random(200),random(50),random(256));
	}
	getch(); // read that keypress

	// loop while not keypressed
	while(!kbhit())
	{
		//draw randomly colored filled circle in random places
		FilledCircle(random(320),random(200),random(50),random(256));
	}
	getch();

	SetTextMode();
}